# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
rust-version = "1.85"
name = "oxicuda-driver"
version = "0.3.0"
authors = ["COOLJAPAN OU <contact@cooljapan.tech>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "OxiCUDA Driver - Dynamic CUDA driver API wrapper via libloading (zero SDK dependency)"
readme = "README.md"
keywords = [
    "cuda",
    "gpu",
    "driver",
    "nvidia",
    "compute",
]
categories = [
    "hardware-support",
    "api-bindings",
]
license = "Apache-2.0"
repository = "https://github.com/cool-japan/oxicuda"
resolver = "2"

[package.metadata.docs.rs]
all-features = true
rustdoc-args = [
    "--cfg",
    "docsrs",
]

[features]
default = []
gpu-tests = []

[lib]
name = "oxicuda_driver"
path = "src/lib.rs"

[[example]]
name = "device_info"
path = "examples/device_info.rs"

[[example]]
name = "jit_logging"
path = "examples/jit_logging.rs"

[[example]]
name = "vector_add"
path = "examples/vector_add.rs"

[[test]]
name = "device_attrs"
path = "tests/device_attrs.rs"

[[test]]
name = "jit_diagnostics"
path = "tests/jit_diagnostics.rs"

[[test]]
name = "macos_stub"
path = "tests/macos_stub.rs"

[[bench]]
name = "occupancy"
path = "benches/occupancy.rs"
harness = false

[dependencies.libloading]
version = "0.9"

[dependencies.thiserror]
version = "2"

[dependencies.tracing]
version = "0.1"

[dev-dependencies.criterion]
version = "0.8"

[lints.clippy]
excessive_precision = "allow"
float_cmp = "allow"
missing_errors_doc = "allow"
missing_panics_doc = "allow"
missing_transmute_annotations = "allow"
module_inception = "allow"
module_name_repetitions = "allow"
similar_names = "allow"
too_many_arguments = "allow"
too_many_lines = "allow"
wildcard_imports = "allow"

[lints.clippy.all]
level = "warn"
priority = -1

[lints.clippy.complexity]
level = "warn"
priority = -1

[lints.clippy.correctness]
level = "deny"
priority = -1

[lints.clippy.perf]
level = "warn"
priority = -1

[lints.clippy.style]
level = "warn"
priority = -1

[lints.clippy.suspicious]
level = "deny"
priority = -1

[lints.rust]
dead_code = "warn"
unsafe_op_in_unsafe_fn = "warn"
unused_imports = "warn"
unused_variables = "warn"
